/* Copyright (c) 2024 Skyward Experimental Rocketry
 * Author: Nicolò Caruso
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include <drivers/DipSwitch/DipSwitch.h>
#include <interfaces-impl/hwmapping.h>
#include <miosix.h>

#include <chrono>

using namespace miosix;
using namespace std::chrono;
using namespace Boardcore;

/**
 * @brief Tests the read from a dipswitch using the DipSwitch driver
 */
int main()
{
    GpioPin sh  = dipSwitch::sh::getPin();
    GpioPin clk = dipSwitch::clk::getPin();
    GpioPin qh  = dipSwitch::qh::getPin();

    DipSwitch dipSwitch(sh, clk, qh, 100us);
    while (true)
    {
        uint8_t status;
        Thread::sleep(1000);
        status = dipSwitch.read();
        printf("Read from dipSwitch: %d\n", status);
    }
    return 0;
}
